Option Explicit

'------- global vars ----------------------------------------------------------
Dim FSO : Set FSO = CreateObject("Scripting.FileSystemObject")
Dim AppDir : AppDir = FSO.GetParentFolderName(FSO.GetParentFolderName(WScript.ScriptFullName))

'******************************************************************************

Dim PluginManager : Set PluginManager = New cl_PluginManager

'******************************************************************************
If WScript.Arguments.Named.Count > 0 Then
	PluginManager.ConfigFolder = WScript.Arguments.Named.Item("config")
	PluginManager.DLLParentFolderAsCategory = WScript.Arguments.Named.Item("DLLParentFolderAsCategory")
Else
	If WScript.Arguments.Count > 0 Then
		PluginManager.ConfigFolder = WScript.Arguments.Item(0)
	End If
	If WScript.Arguments.Count > 1 Then
		PluginManager.DLLParentFolderAsCategory = WScript.Arguments.Item(1)
	End If
End If

'******************************************************************************
PluginManager.Update False




'******************************************************************************
Class cl_PluginManager

'==============================================================================
	Private FSO, WSH
	Private CategoryFiles
	Private CachedInfos
	Private AutomapClients
	Private ScannedFiles
	Private VSTScanPaths
	Private CacheIsValid
	Private PlugInfos
	Private Hosts
	Private BinDir
	Private JBridgeDir
	Private CheckjBridge
	Private CheckNamesUnique
	Private AutomapDir
	Private Messager
	Private IndexHTMLStream
'------------------------------------------------------------------------------	
	Private myDLLParentFolderAsCategory
	Public Property Let DLLParentFolderAsCategory(value)
		If value <> "" Then myDLLParentFolderAsCategory = True
	End Property
	
'------------------------------------------------------------------------------	
	Private myConfigFolder
	Public Property Let ConfigFolder(Folder)
		Dim DefaultConfigStream
		If Folder = "" Then
			On Error Resume Next
			Set DefaultConfigStream = FSO.OpenTextFile(FSO.BuildPath(AppDir, "/data/default.ini"), 1)
			If Err.Number = 0 Then
				Folder = DefaultConfigStream.ReadLine
				DefaultConfigStream.Close
			End If
			On Error Goto 0
			If Folder = "" Then
				Folder = "default"
			End If
		End if
		If myConfigFolder = "" Then
			If FSO.FolderExists(FSO.BuildPath(AppDir, "configs\" & Folder )) = False Then
				myConfigFolder = FSO.CreateFolder(FSO.BuildPath(AppDir, "configs\" & Folder )).Path
			Else
				myConfigFolder = FSO.GetFolder(FSO.BuildPath(AppDir, "configs\" & Folder )).Path
			End If
			On Error Resume Next
			FSO.CreateFolder FSO.BuildPath(myConfigFolder, "cache")
			FSO.CreateFolder FSO.BuildPath(myConfigFolder, "cache/categories")
			FSO.CreateTextFile FSO.BuildPath(myConfigFolder, "cache/VSTScanPaths.ini"), False
			FSO.CreateFolder FSO.BuildPath(myConfigFolder, "hosts")
			On Error Goto 0
			CacheFolder = FSO.BuildPath(myConfigFolder, "cache")
			HostsFolder = FSO.BuildPath(myConfigFolder, "hosts")
			Set DefaultConfigStream = FSO.OpenTextFile(FSO.BuildPath(AppDir, "/data/default.ini"), 2, True)
			DefaultConfigStream.WriteLine Folder
			DefaultConfigStream.Close
			Dim HTMLStream : Set HTMLStream = FSO.OpenTextFile(FSO.BuildPath(myCacheFolder, "cache.html"), 2, True)
			HTMLStream.Write "<html><head><title>VST2 Plugin Manager - Configuration '" & Folder & "' - Cache</title></head><body scroll='auto' style='background-image:url(""../../../data/PluginManager.jpg"");background-repeat:no-repeat;background-position:10px 5px'><nobr><h1>VST2 Plugin Manager - Configuration '" & Folder & "'</h1></nobr><nobr><a href='VSTScanPaths.ini'>edit VST Scan Paths</a>&nbsp<a href='file://" & FSO.BuildPath(myCacheFolder, "categories") & "' target='PluginList'>edit categories</a></nobr></body></html>"
			HTMLStream.Close
			Set HTMLStream = FSO.OpenTextFile(FSO.BuildPath(myConfigFolder, "index.html"), 2, True)
			HTMLStream.Write "<html><head><title>VST2 Plugin Manager - Configuration '" & Folder & "'</title></head><frameset rows='15%,*'><frame src='cache/cache.html' name='Cache'><frameset cols='25%,*'><frame src='hosts/HostsList.html' name='HostList'><frame name='PluginList'></frameset></frameset></html>"
			HTMLStream.Close
		ElseIf Folder <> myConfigFolder Then
			Me = New cl_PluginManager.ConfigFolder = Folder
		End If
	End Property

'------------------------------------------------------------------------------	
	Private myCacheFolder
	Private Property Let CacheFolder(Folder)
		If myCacheFolder = "" Then
			If ReadCache(Folder) = True Then 
				myCacheFolder = Folder
				CacheIsValid = True
			End If
		ElseIf myCacheFolder <> Folder Then
			CachedInfos.RemoveAll
			PlugInfos.RemoveAll
			myCacheFolder = ""
			Me.CacheFolder = Folder
		End If
	End Property
		
'------------------------------------------------------------------------------	
	Private myHostsFolder
	Private Property Let HostsFolder(Folder)
		If myHostsFolder = "" Then
			If ReadHosts(Folder) = True Then 
				myHostsFolder = Folder
			End If
		ElseIf myHostsFolder <> Folder Then
			Hosts.RemoveAll
			myHostsFolder = ""
			Me.HostsFolder = Folder
		End If
	End Property
		
'==============================================================================
	Public Sub Class_Terminate
		If isEmpty(IndexHTMLStream) Then
		Else
			IndexHTMLStream.Write "<html><head><title>VST2 Plugin Manager - Configurations</title></head><body scroll='auto' style='background-image:url(""./data/PluginManager.jpg"");background-repeat:no-repeat;background-position:10px 5px'><nobr><h1>VST2 Plugin Manager - Configurations</h1></nobr>"
			Dim Folder : For Each Folder in FSO.GetFolder(FSO.BuildPath(AppDir, "configs")).SubFolders
				IndexHTMLStream.Write "<nobr><a href='" & FSO.BuildPath(Folder , "index.html") & "'>" & Folder.Name & "</a></nobr><br>"
			Next
			IndexHTMLStream.Write "</body></html>"
			IndexHTMLStream.Close
		End If
	End Sub
	
'==============================================================================
	Public Sub Class_Initialize
		Set FSO = CreateObject("Scripting.FileSystemObject")
		On Error Resume Next
		Set IndexHTMLStream = FSO.OpenTextFile(FSO.BuildPath(AppDir, "index.html"), 2, True)	
		If Err.Number <> 0 Then
			MsgBox "The Plugin Manager seems to be running already. Try again later!", , "VST2 Plugin Manager"
			WScript.Quit(0)
		End If
		On Error Goto 0
		Set WSH = CreateObject("WScript.Shell")
		Set CategoryFiles = CreateObject("Scripting.Dictionary")
		Set CachedInfos = CreateObject("Scripting.Dictionary")
		Set PlugInfos = CreateObject("Scripting.Dictionary")
		Set Hosts = CreateObject("Scripting.Dictionary")
		Set ScannedFiles = CreateObject("Scripting.Dictionary")
		Set VSTScanPaths = CreateObject("Scripting.Dictionary")
		Set AutomapClients = CreateObject("Scripting.Dictionary")
		CacheIsValid = False
		myDLLParentFolderAsCategory = False
		Set BinDir = FSO.GetFolder(FSO.BuildPath(AppDir, "\data"))
		On Error Resume Next
		Set JBridgeDir = FSO.GetFolder(FSO.GetParentFolderName(WSH.RegRead("HKEY_LOCAL_MACHINE\Software\Wow6432Node\JBridge\Proxy32")))
		Set AutomapDir = FSO.GetFolder(WSH.RegRead("HKEY_CURRENT_USER\Software\Novation\Automap Server\AutomapDir"))
		Dim TextStream : Set TextStream = FSO.GetFile(FSO.BuildPath(AutomapDir ,"AutomapClients.ini")).OpenAsTextStream
		Dim Content : Content = Split(TextStream.ReadAll, vbCrLf) : TextStream.Close : Set TextStream = Nothing
		If Not Err Then
			Dim Line : Dim Key : For Each Line in Content
				If InStr(Line, "[") > 0 and InStrRev(Line, "]") > 0 Then
					Key = Mid(Line, 2, Len(Line) - 2)
				ElseIf Line <> "" Then
					If AutomapClients.Exists(Key) Then
						AutomapClients(Key) = Line
					Else
						AutomapClients.Add Key, Line
					End If
					Key = ""
				End If
			Next
		End If
		TextStream.Close
		On Error Goto 0
		Set Messager = New cl_Messager
	End Sub

'==============================================================================
	Private Function Categorize
		Dim Dialog : Set Dialog = CreateObject("Shell.Application")
		Messager.Write "action", "Categorize your plugins..."
		On Error Resume Next
		FSO.DeleteFolder(FSO.BuildPath(myCacheFolder, "categories.bak"))
		On Error Goto 0
		Do While FSO.FolderExists(FSO.BuildPath(myCacheFolder, "categories.bak"))
			WScript.Sleep 1000
		Loop
		On Error Goto 0
		WScript.Sleep 1000
		FSO.GetFolder(FSO.BuildPath(myCacheFolder, "categories")).Copy FSO.BuildPath(myCacheFolder, "categories.bak")
		On Error Resume Next
		If Dialog.BrowseForFolder(&H0, "edit and categorize plugins to your liking:", &H4040, FSO.BuildPath(myCacheFolder, "categories")) = "" Then
			Messager.Write "status1", "undo categorization..."
			On Error Goto 0
			FSO.DeleteFolder(FSO.BuildPath(myCacheFolder, "categories"))
			Do While FSO.FolderExists(FSO.BuildPath(myCacheFolder, "categories"))
				WScript.Sleep 1000
			Loop
			WScript.Sleep 1000
			On Error Goto 0
			FSO.GetFolder(FSO.BuildPath(myCacheFolder, "categories.bak")).Move FSO.BuildPath(myCacheFolder, "categories")
			Messager.Write "status1", ""
			Categorize = False
		Else
			Categorize = True
		End If
		On Error Goto 0
		Messager.Write "action", ""
	End Function

	'==============================================================================
	Private Function AddVSTScanPath(Folder)
		If FSO.FolderExists(Folder) Then
			Dim VSTScanPath : For Each VSTScanPath in VSTScanPaths
				If InStr(FSO.GetFolder(Folder).Path & "\", FSO.GetFolder(VSTScanPath).Path & "\") = 1 Then
					AddVSTScanPath = True
					Exit Function
				ElseIf InStr(FSO.GetFolder(VSTScanPath).Path & "\", FSO.GetFolder(Folder).Path & "\" ) = 1 Then
					VSTScanPaths.Key(VSTScanPath) = Folder
					AddVSTScanPath = True
					CacheIsValid = False
					Exit Function
				End If
			Next
			VSTScanPaths.Add Folder, ""
			AddVSTScanPath = True
			CacheIsValid = False
		Else
			AddVSTScanPath = False
		End If
	End Function

'==============================================================================
	Private Function RemoveVSTScanPath(Folder)
		If VSTScanPaths.Exists(Folder) Then
			VSTScanPaths.Remove(Folder)
			CacheIsValid = False
			RemoveVSTScanPath = True
		Else
			RemoveVSTScanPath = False
		End If
	End Function

	'==============================================================================
	Public Function Update(hard)
		If UpdateCache(hard) = True Then
			If UpdateHosts(hard) = True Then
				Messager.Write "action", "finished..."
				Messager.Write "status2", "(this window will close automatically)"
				WScript.Sleep 1000
				Update = True
				Exit Function
			End If
		End If
		Messager.Write "action", ""
		Update = False
		MsgBox "An error occured. Not all hosts scan paths might be up to date...", , "VST2 Plugin Manager"
	End Function
	
	'==============================================================================
	Private Function UpdateHosts(hard)
		If myConfigFolder = "" Then ConfigFolder = "" 
		Messager.Write "action", "Updating Hosts Plugin Scan Paths..."
		If myHostsFolder = "" Then UpdateHosts = False : Exit Function
		If CacheIsValid = False Then UpdateHosts = False : Exit Function
		If BuildPlugInfos() = False Then UpdateHosts = False : Exit Function
		Dim HTMLStream : Set HTMLStream = FSO.OpenTextFile(FSO.BuildPath(myHostsFolder, "HostsList.html"), 2, True)
		HTMLStream.Write "<html><head><title>VST2 Plugin Manager - Configuration '" & FSO.GetFolder(myConfigFolder).Name & "' - HostsList</title></head><body><nobr><b>Hosts</b> <a href='file://" & myHostsFolder & "' target='PluginList'>(edit)</a></nobr><hr>"
		CheckNamesUnique = False
		UpdateHosts = True
		Dim Host: For Each Host in Hosts
			Messager.Write "status1", Host
			HTMLStream.Write "<nobr><a href='" & Host & "/PluginList.html' target='PluginList'>" & Host & "</a></nobr><br>"
			If CreatePluginsFor(Host, hard) = False Then UpdateHosts = False
			Messager.Write "status1", ""
		Next
		HTMLStream.Write "</body></html>"
		HTMLStream.Close
		Messager.Write "action", ""
	End Function

'==============================================================================
	Private Function CreatePluginsFor(Host, hard)
		if CacheIsValid = False Then CreatePluginsFor = False : Exit Function
 		Dim DllNames : Set DllNames = CreateObject("Scripting.Dictionary")
		'-- default usage for host
		Dim defaultUsage, CheckDefaultUsage
		Dim HostFolder : Set HostFolder = FSO.GetFolder(FSO.BuildPath(myHostsFolder, Host))
		On Error Resume Next
		FSO.CreateFolder(FSO.BuildPath(HostFolder.Path, "data"))
		Err.Number = 0
		Dim TextStream : Set TextStream = FSO.OpenTextFile(FSO.BuildPath(HostFolder.Path, "default.ini"), 1)
		If Err.Number = 0 Then
			defaultUsage = LCase(TextStream.ReadLine)
		Else 
			FSO.CreateTextFile(FSO.BuildPath(HostFolder.Path, "default.ini"))
		End If
		TextStream.Close
		On Error Goto 0
		If defaultUsage = "@preserve" Then CreatePluginsFor = True : Exit Function
		If FSO.FolderExists(FSO.BuildPath(HostFolder.Path, "categories")) Then
			On Error Resume Next
			FSO.DeleteFolder(FSO.BuildPath(HostFolder.Path, "categories"))
			If Err.Number <> 0 Then
				MsgBox "can't update Scan Path for " & Host & ". Maybe the Host is currently running and using Plugins? Quit the Host and try again later!"
				Exit Function
			End If
			On Error Goto 0
		End If
		Dim DataFolder : Set DataFolder = FSO.GetFolder(FSO.BuildPath(HostFolder.Path, "data"))
		Dim File : For Each File in DataFolder.Files
			On Error Resume Next
			If LCase(FSO.GetExtensionName(File)) <> "jbridge" Then FSO.DeleteFile(File)
			If Err.Number <> 0 Then
				MsgBox "can't update Scan Path for " & Host & ". Maybe the Host is currently running and using Plugins? Quit the Host and try again later!"
				Exit Function
			End If
			On Error Goto 0
		Next
		Do While FSO.FolderExists(FSO.BuildPath(HostFolder.Path, "categories")) = True Or FSO.FolderExists(FSO.BuildPath(HostFolder.Path, "data")) = False
			WScript.Sleep 1000
		Loop
		WScript.Sleep 1000
		Dim CategoryFolder : Set CategoryFolder = FSO.CreateFolder(FSO.BuildPath(HostFolder.Path, "categories"))
		Dim HTMLStream : Set HTMLStream = FSO.OpenTextFile(FSO.BuildPath(HostFolder.Path, "PluginList.html"), 2, True)
		HTMLStream.Write "<html><head><title>VST2 Plugin Manager - Configuration '" & FSO.GetFolder(myConfigFolder).Name & "' - Host '" & Host & "' - PluginList</title></head><body><h3>Host '" & Host & "'</h3><b><nobr>default Plugin usage: '" & defaultUsage & "'</b> (<a href='file://" & FSO.BuildPath(HostFolder.Path, "default.ini") & "'>edit</a>)</nobr><br><nobr>use the Plugin Path <b><i>" & CategoryFolder.Path & "</i></b> in your host.</nobr><br><br>Plugins<hr><table>"
		CreatePluginsFor = True
		Dim DllName, Category, Use, Usage, PlugInfo, Fail : For Each PlugInfo in PlugInfos
			'-- DllName
			DllName = PlugInfos(PlugInfo)("Names")("@all")
			If PlugInfos(PlugInfo)("Names").Exists(LCase(Host)) And PlugInfos(PlugInfo)("Names")(LCase(Host)) <> "@defaultName" Then DllName = PlugInfos(PlugInfo)("Names")(LCase(Host))
			If FSO.FileExists(PlugInfos(PlugInfo)("ini")) Then 
				HTMLStream.Write "<tr><td><nobr><b><a href='" & PlugInfos(PlugInfo)("ini") & "'>"& DllName & "</a>&nbsp&nbsp&nbsp&nbsp</b></nobr></td>"
			Else
				HTMLStream.Write "<tr><td><nobr><b><a href='" & FSO.BuildPath(FSO.GetFolder(FSO.BuildPath(myCacheFolder, "categories")).Path, PlugInfos(PlugInfo)("ini")) & "'>"& DllName & "</a>&nbsp&nbsp&nbsp&nbsp</b></nobr></td>"
			End If
			'-- category folder erzeugen
			If FSO.FileExists(PlugInfos(PlugInfo)("ini")) Then 
				HTMLStream.Write "<td><nobr><a href='" & FSO.GetFile(PlugInfos(PlugInfo)("ini")).ParentFolder.Path & "' target='PluginList'>"
			Else
				HTMLStream.Write "<td><nobr><a href='" & FSO.GetFolder(FSO.BuildPath(myCacheFolder, "categories")).Path & "' target='PluginList'>"
			End If
			Set CategoryFolder = FSO.GetFolder(FSO.BuildPath(HostFolder.Path, "categories"))
			For Each Category in PlugInfos(PlugInfo)("Category")
				HTMLStream.Write Category & "/"
				If FSO.FolderExists(FSO.BuildPath(CategoryFolder.Path, Category)) = False Then
					FSO.CreateFolder(FSO.BuildPath(CategoryFolder.Path, Category))
				End If
				Set CategoryFolder = FSO.GetFolder(FSO.BuildPath(CategoryFolder.Path, Category))
			Next
			If UBound(PlugInfos(PlugInfo)("Category")) = -1 Then
				HTMLStream.Write "<i>no category</i>"
			End If
			HTMLStream.Write "</a>&nbsp&nbsp&nbsp&nbsp</nobr></td>"
			'-- plugin fr host relevant?
			If PlugInfos(PlugInfo)("Hosts").Exists("@none") Then
				HTMLStream.Write "<td><nobr><i>(excluded)&nbsp&nbsp&nbsp&nbsp</i></nobr></td>"
			Else
				If Not (PlugInfos(PlugInfo)("Hosts").Exists("@all") Or PlugInfos(PlugInfo)("Hosts").Exists(LCase(Host))) Then
					HTMLStream.Write "<td><nobr><i>(excluded)&nbsp&nbsp&nbsp&nbsp</i></nobr></td>"
				Else
					Messager.Write "status2", DllName
					'-- usage
					Usage = defaultUsage
					If PlugInfos(PlugInfo)("Usages").Exists(LCase(Host)) And PlugInfos(PlugInfo)("Usages")(LCase(Host)) <> "@defaultUsage" Then
						Usage = PlugInfos(PlugInfo)("Usages")(LCase(Host))
						HTMLStream.Write "<td><nobr>" & Usage & "&nbsp&nbsp&nbsp&nbsp</nobr></td>"
					Else
						If Usage = "" Then
							If CheckDefaultUsage <> True Then
								MsgBox "There's no default plugin usage (default.ini) specified for " & Host & Chr(13) & "Only Plugins with specific uasge will be created!", , "VST2 Plugin Manager"
								CheckDefaultUsage = True
							End if
							HTMLStream.Write "<td><nobr>(no usage specified)&nbsp&nbsp&nbsp&nbsp</nobr></td>"
						Else
							HTMLStream.Write "<td><nobr>&nbsp&nbsp&nbsp&nbsp</nobr></td>"
						End If
					End If
					Fail = False
					If DllNames.Exists(DllName) = True Then
						If CheckNamesUnique <> True Then
							MsgBox "The plugin name '" & DllName & "' is not unique! Only the first plugin with that name will be available to your host!", , "VST2 Plugin Manager"
						End If
						Fail = True
					Else
						For Each Use in Split(Usage, "|")
							If Use = "@none" Then
								Exit For
							End If
							If LCase(Left(Use, 1)) = "j" Then
								If PlugInfos(PlugInfo)("Files").Exists(Right(Use, Len(Use) - 3)) Then
									If JBridgeDir <> "" And JBridgeDir <> "-" Then
										Fail = True
										If CreateProxy(FSO.BuildPath(BinDir, "PluginLoader." & Right(Use, 2) & ".dll"), DataFolder, FSO.GetBaseName(PlugInfos(PlugInfo)("Files")(Right(Use, Len(Use) - 3))(0)) & "." & Left(Use, 3) & "s" & Right(Use,2), PlugInfos(PlugInfo)("Files")(Right(Use, Len(Use) - 3))(0)) = True Then
											If CreateProxy(FSO.BuildPath(JBridgeDir, "plugin_name." & Mid(Use, 2, 2) & ".dll"), CategoryFolder, DllName, FSO.BuildPath(DataFolder.Path, FSO.GetBaseName(PlugInfos(PlugInfo)("Files")(Right(Use, Len(Use) - 3))(0)) & "." & Left(Use, 3) & "s" & Right(Use,2) & ".dll")) = True Then
												DllNames.Add DllName, ""
												HTMLStream.Write "<td><nobr>x" & Mid(Use, 2, 2) & "&nbsp&nbsp&nbsp&nbsp</nobr></td>"
												HTMLStream.Write "<td><nobr>jBridged x" & Right(Use, 2) & " <a href='" & FSO.BuildPath(DataFolder.Path, FSO.GetBaseName(PlugInfos(PlugInfo)("Files")(Right(Use, Len(Use) - 3))(0)) & "." & Left(Use, 3) & "s" & Right(Use,2) & ".jbridge") & "'>(jBridge settings)</a>&nbsp&nbsp&nbsp&nbsp</nobr></td>"
												If InStr(Use, "a") > 0 Then
													HTMLStream.Write "<td><nobr>Automap enabled&nbsp&nbsp&nbsp&nbsp</nobr></td>"
												Else
													HTMLStream.Write "<td><nobr>&nbsp&nbsp&nbsp&nbsp&nbsp</nobr></td>"
												End If
												HTMLStream.Write "<td><nobr><i>" & PlugInfos(PlugInfo)("Files")(Right(Use, Len(Use) - 3))(0) & "</i></nobr></td>"
												Fail = False
												Exit For
											End If
										End If
									Else
										If JBridgeDir = "" Then
											MsgBox "could not create a jBridge DLL for " & DllName & ". jBridge seems to be unavailable on this system!", , "VST2 Plugin Manager"
											JBridgeDir = "-"
										End If
										Fail = True
									End If
								End If
							Else
								If PlugInfos(PlugInfo)("Files").Exists(Use) Then
									Fail = True
									If CreateProxy(FSO.BuildPath(BinDir, "PluginLoader." & Right(Use, 2) & ".dll"), CategoryFolder, DllName, PlugInfos(PlugInfo)("Files")(Use)(0)) = True Then
										DllNames.Add DllName, ""
										HTMLStream.Write "<td><nobr>x" & Right(Use, 2) & "&nbsp&nbsp&nbsp&nbsp</nobr></td>"
										HTMLStream.Write "<td><nobr>&nbsp&nbsp&nbsp&nbsp&nbsp</nobr></td>"
										If InStr(Use, "a") > 0 Then
											HTMLStream.Write "<td><nobr>Automap enabled&nbsp&nbsp&nbsp&nbsp</nobr></td>"
										Else
											HTMLStream.Write "<td><nobr>&nbsp&nbsp&nbsp&nbsp&nbsp</nobr></td>"
										End If
										HTMLStream.Write "<td><nobr><i>" & PlugInfos(PlugInfo)("Files")(Use)(0) & "</i></nobr></td>"
										Fail = False
										Exit For
									End If
								End If
							End If
						Next
					End If
					If Fail = True Then
						HTMLStream.Write "<td><nobr><i>(not available)&nbsp&nbsp&nbsp&nbsp</i></nobr></td>"
						HTMLStream.Write "<td><nobr>&nbsp&nbsp&nbsp&nbsp&nbsp</nobr></td>"
						HTMLStream.Write "<td><nobr>&nbsp&nbsp&nbsp&nbsp&nbsp</nobr></td>"
						HTMLStream.Write "<td><nobr>&nbsp&nbsp&nbsp&nbsp&nbsp</nobr></td>"
						CreatePluginsFor = False
					End If
				End If
			End If
			HTMLStream.Write "</tr>"
		Next
		HTMLStream.Write "</tr></table><hr></body></html>"
		HTMLStream.Close
		If CreatePluginsFor = False Then
			MsgBox "could not create all desired ('" & Usage & "') plugin DLLs for '" & Host & "'!", , "VST2 Plugin Manager"
		End If
		Messager.Write "status2", ""
	End Function

'==============================================================================
	Private Function CreateProxy(ProxyDllPath, Folder, BaseName, Target)
		CreateProxy = False
		If FSO.FileExists(FSO.BuildPath(Folder.Path, BaseName & ".dll")) Then Exit Function
		On Error Resume Next
		FSO.CopyFile ProxyDllPath, FSO.BuildPath(Folder.Path, BaseName & ".dll")
		CreateObject("Shell.Application").NameSpace(Folder.Path).ParseName(BaseName & ".dll").ModifyDate = FSO.GetFile(Target).DateLastModified
		Dim TextStream : Set TextStream = FSO.CreateTextFile(FSO.BuildPath(Folder.Path, BaseName & ".txt"), True)
		TextStream.WriteLine("""" & Target & """") : TextStream.Close
		If Err.Number = 0 Then CreateProxy = True
		On Error Goto 0
	End Function
		
'==============================================================================
	Private Function BuildPlugInfos()
		If CacheIsValid = False Then BuildPlugInfos = False : Exit Function
		PlugInfos.RemoveAll
		Dim RootFolder, ID, Host, CachedInfo : For Each CachedInfo in CachedInfos
			ID = FSO.GetBaseName(CachedInfos(CachedInfo)("ID"))
			If PlugInfos.Exists(ID) = False Then
				PlugInfos.Add ID, CreateObject("Scripting.Dictionary")
				PlugInfos(ID).Add "ini", CachedInfos(CachedInfo)("ID")
				PlugInfos(ID).Add "Files", CreateObject("Scripting.Dictionary")
				PlugInfos(ID).Add "Category", Array()
				PlugInfos(ID).Add "Names", CreateObject("Scripting.Dictionary")
				PlugInfos(ID).Add "Hosts", CreateObject("Scripting.Dictionary")
				PlugInfos(ID).Add "Usages", CreateObject("Scripting.Dictionary")
			End If
			If CachedInfo = ID & ".hostedby" Then
				For Each Host in Split(CachedInfos(CachedInfo)("Usage"), "|")
					PlugInfos(ID)("Hosts").Add LCase(Host), CachedInfos(CachedInfo)("Usage")
					PlugInfos(ID)("Names").Add "@all", CachedInfos(CachedInfo)("As")
				Next
			ElseIf InStr(CachedInfo, ID & ".usagein:") = 1 Then
				Host = LCase(Right(CachedInfo, Len(CachedInfo) - Len(ID) - 9 ))
				PlugInfos(ID)("Usages").Add LCase(Host), CachedInfos(CachedInfo)("Usage")
				PlugInfos(ID)("Names").Add LCase(Host), CachedInfos(CachedInfo)("As")
			ElseIf CachedInfos(CachedInfo)("Type") <> "" And CachedInfos(CachedInfo)("Active") = "X" Then
				If UBound(PlugInfos(ID)("Category")) = -1 Then
					RootFolder = FSO.BuildPath(myCacheFolder, "categories")
					If InStr(CachedInfos(CachedInfo)("ID"), RootFolder) = 1 Then PlugInfos(ID)("Category") = Split(FSO.GetParentFolderName(Right(CachedInfos(CachedInfo)("ID"), Len(CachedInfos(CachedInfo)("ID")) - Len(RootFolder) - 1)), "\")
				End If
				If PlugInfos(ID)("Files").Exists(CachedInfos(CachedInfo)("Type")) Then
					If PlugInfos(ID)("Files")(CachedInfos(CachedInfo)("Type"))(1) < CachedInfos(CachedInfo)("Created") _
					Or PlugInfos(ID)("Files")(CachedInfos(CachedInfo)("Type"))(2) < CachedInfos(CachedInfo)("LastModified") Then
						PlugInfos(ID)("Files")(CachedInfos(CachedInfo)("Type")) = Array(CachedInfo, CachedInfos(CachedInfo)("Created"), CachedInfos(CachedInfo)("LastModified"))
					End If
				Else
					PlugInfos(ID)("Files").Add CachedInfos(CachedInfo)("Type"), Array(CachedInfo, CachedInfos(CachedInfo)("Created"), CachedInfos(CachedInfo)("LastModified"))
				End If
			End If
		Next
		Dim PlugInfo : For Each PlugInfo in PlugInfos
			If PlugInfos(PlugInfo)("Files").Count = 0 Then PlugInfos.Remove(PlugInfo)
		Next
		BuildPlugInfos = True
	End Function
	
	'==============================================================================
	Private Function UpdateCache(hard)
		If myConfigFolder = "" Then ConfigFolder = ""
		Messager.Write "action", "Updating cached VST2 Plugin information..."
		If myCacheFolder = "" Then UpdateCache = False : Exit Function
		'-- Scan VSTs
		Messager.Write "status1", "Scanning for DLL changes/additions..."
		CheckjBridge = False
		Dim newDlls : Dim VSTScanPath: For Each VSTScanPath in VSTScanPaths
			Scan VSTScanPath, hard, newDlls
		Next
		'-- (De)Activate Cached Dlls according to inclution in Scan Paths
		Messager.Write "status1", "updating cached plugin information..."
		Dim usageIn, hostedBy, Host, CachedInfo : For Each CachedInfo in CachedInfos
			If CachedInfos(CachedInfo).Exists("Active") Then
				If CachedInfos(CachedInfo)("Active") <> "inactive" Then
					If FSO.FileExists(CachedInfo) Then
						CachedInfos(CachedInfo)("Active") = " "
						For Each VSTScanPath in VSTScanPaths
							If InStr(LCase(CachedInfo), LCase(VSTScanPath)) = 1 Then 
								CachedInfos(CachedInfo)("Active") = "X"
								Exit For
							End If
						Next
					End If
				End If
			End If
			'-- create "hosted by" entry
			hostedBy = FSO.GetBaseName(CachedInfos(CachedInfo)("ID")) & ".hostedby"
			If CachedInfo <> hostedBy Then
				If CachedInfos.Exists(hostedBy) = False Then
					CachedInfos.Add hostedBy, CreateObject("Scripting.Dictionary")
					CachedInfos(hostedBy).Add "ID", CachedInfos(CachedInfo)("ID")
					If CachedInfos(CachedInfo)("ID") = "!NoVSTPluginDLL.ini" Then
						CachedInfos(hostedBy).Add "Usage", "@none"
					Else
						CachedInfos(hostedBy).Add "Usage", "@all"
					End If
					CachedInfos(hostedBy).Add "As", ""
				End If
				If CachedInfos(hostedBy)("As") = "" Then
					If CachedInfos(CachedInfo)("Type") = "x32" Then
						CachedInfos(hostedBy)("As") = FSO.GetBaseName(CachedInfo)
					Else
						If CachedInfos(CachedInfo)("Type") = "x64" And CachedInfos(hostedBy)("As") = "" Then
							CachedInfos(hostedBy)("As") = FSO.GetBaseName(CachedInfo)
						End If
					End If
				End If
			End If
			'-- create "usage in" entries for all hosts
			usageIn = FSO.GetBaseName(CachedInfos(CachedInfo)("ID")) & ".usagein:"
			If InStr(CachedInfo, usageIn) = 0 Then
				If FSO.GetBaseName(CachedInfos(CachedInfo)("ID")) <> "!NoVSTPluginDLL" Then
					For Each Host in Hosts
						If CachedInfos.Exists(usageIn & LCase(Host)) = False Then
							CachedInfos.Add usageIn & LCase(Host), CreateObject("Scripting.Dictionary")
							CachedInfos(usageIn & LCase(Host)).Add "ID", CachedInfos(CachedInfo)("ID")
							CachedInfos(usageIn & LCase(Host)).Add "Usage", "@defaultUsage"
							CachedInfos(usageIn & LCase(Host)).Add "As", "@defaultName"
						End If
						If CachedInfos(hostedBy)("As") = "" Then
							CachedInfos(usageIn & LCase(Host))("As") = "@defaultName"
						End If
					Next
				End If
			End If
			'-- delete "usage in" for non-existent hosts
			if hard = True Then 
				If InStr(CachedInfo, ".usagein:") > 1 Then
					Host = "/" & Right(CachedInfo, Len(CachedInfo) - InStr(CachedInfo, ".usagein:") - 8 ) & "/"
					If InStr(LCase("/" & Join(Hosts.Keys, "/") & "/"), Host) = 0  Then
						CachedInfos.Remove(CachedInfo)
					End If
				End If
			End If
		Next
		If CachedInfos.Count = 0 And VSTScanPaths.Count <> 0 Then
			MsgBox "No Plugins found...", , "VST2 Plugin Manager"
		End If
		'-- Write cache
		Messager.Write "status1", ""
		If WriteCache(myCacheFolder) = False Then UpdateCache = False : Exit Function
		If newDlls = True Then
			CacheIsValid = False
			If Categorize() = True Then
				Messager.Write "status1", "updating categories..."
				CategoryFiles.RemoveAll
				CachedInfos.RemoveAll
				If ReadCategories(FSO.BuildPath(myCacheFolder, "categories")) = False Then
					CacheIsValid = False
					UpdateCache = False
					Exit Function
				End If
			End If
		End If
		Messager.Write "action", ""
		CacheIsValid = True
		UpdateCache = True
	End Function

'==============================================================================
	Private Function ReadHosts(HostsFolder)
		ReadHosts = False
		On Error Resume Next
		Dim SubFolder : For Each SubFolder in FSO.GetFolder(HostsFolder).SubFolders
			Hosts.Add SubFolder.Name, SubFolder
		Next
		If Err.Number > 0 Or Hosts.Count = 0 Then
			MsgBox "No Hosts specified in " & myConfigFolder & "\hosts\" & Chr(13) & "There can't be any Host Scan Path created!", , "VST2 Plugin Manager"
		End If
		On Error Goto 0
		ReadHosts = True
	End Function

'==============================================================================
	Private Function WriteCache(CacheFolder)
		Dim VSTScanPath, TextStream
		Messager.Write "action", "Writing cached VST2 Plugin information..."
		On Error Resume Next
		Set TextStream = FSO.CreateTextFile(FSO.BuildPath(CacheFolder, "VSTScanPaths.ini"), True)
		If Err.Number <> 0 Then WriteCache = False : Exit Function
		On Error Goto 0
		For Each VSTScanPath in VSTScanPaths
			TextStream.WriteLine VSTScanPath
		Next
		WriteCache = WriteCategories(FSO.BuildPath(CacheFolder, "categories"))
		Messager.Write "action", ""
	End Function
	
'==============================================================================
	Private Function WriteCategories(CategoryFolder)
		Dim ID, NewCategory, TextStreams : Set TextStreams = CreateObject("Scripting.Dictionary")
		Dim CachedInfo, CacheInfo : For Each CacheInfo in CachedInfos.Items
		ID = FSO.GetBaseName(CacheInfo("ID"))
			If Not TextStreams.Exists(ID) Then
				On Error Resume Next
				TextStreams.Add ID, FSO.OpenTextFile(CacheInfo("ID"), 2, False)
				If Err.Number <> 0 Then
					On Error Goto 0
					NewCategory = ""
					If myDLLParentFolderAsCategory <> False And ID <> "!NoVSTPluginDLL" Then
					On Error Resume Next
						For Each CachedInfo in CachedInfos
							If FSO.GetBaseName(CachedInfos(CachedInfo)("ID")) = ID Then
								NewCategory = FSO.GetFolder(FSO.GetParentFolderName(CachedInfo)).Name
								Exit For
							End If
						Next
						On Error Goto 0
					End If
					If NewCategory <> "" Then
						If FSO.FolderExists(FSO.BuildPath(CategoryFolder, NewCategory)) Then
							NewCategory = FSO.GetFolder(FSO.BuildPath(CategoryFolder, NewCategory)).Path
						Else
							NewCategory = FSO.CreateFolder(FSO.BuildPath(CategoryFolder, NewCategory)).Path
						End If
						TextStreams.Add ID, FSO.CreateTextFile(FSO.BuildPath(NewCategory, CacheInfo("ID")), True)
					End If
					If Err.Number <> 0 Or NewCategory = "" Then
						TextStreams.Add ID, FSO.CreateTextFile(FSO.BuildPath(CategoryFolder, CacheInfo("ID")), True)
					End If
					On Error Goto 0
				End If
				On Error Goto 0
			End If
		Next
		For Each CachedInfo in CachedInfos
			ID = FSO.GetBaseName(CachedInfos(CachedInfo)("ID"))
			If CachedInfo = ID & ".hostedby" Then
				TextStreams(ID).WriteLine LCase(Right(CachedInfo, Len(CachedInfo) - Len(ID) - 1 )) & Chr(06) & CachedInfos(CachedInfo)("Usage") & Chr(06) & CachedInfos(CachedInfo)("As")
			ElseIf InStr(CachedInfo, ID & ".usagein:") = 1 Then
			Else
			End If
		Next
		For Each CachedInfo in CachedInfos
			ID = FSO.GetBaseName(CachedInfos(CachedInfo)("ID"))
			If CachedInfo = ID & ".hostedby" Then
			ElseIf InStr(CachedInfo, ID & ".usagein:") = 1 Then
				TextStreams(ID).WriteLine LCase(Right(CachedInfo, Len(CachedInfo) - Len(ID) - 1 )) & Chr(06) & CachedInfos(CachedInfo)("Usage") & Chr(06) & CachedInfos(CachedInfo)("As")
			Else
			End If
		Next
		For Each CachedInfo in CachedInfos
			ID = FSO.GetBaseName(CachedInfos(CachedInfo)("ID"))
			If CachedInfo = ID & ".hostedby" Then
			ElseIf InStr(CachedInfo, ID & ".usagein:") = 1 Then
			Else
				TextStreams(ID).WriteLine CachedInfo & Chr(06) & CachedInfos(CachedInfo)("Created") & Chr(06) & CachedInfos(CachedInfo)("LastModified") & Chr(06) & CachedInfos(CachedInfo)("Type") & Chr(06) & CachedInfos(CachedInfo)("Active")
			End If
		Next
		Dim TextStream : For Each TextStream in TextStreams
			TextStreams(TextStream).Close
		Next
		WriteCategories = True
	End Function

'==============================================================================
	Private Function ReadCache(CacheFolder)	
		Dim TextStream, Content, Line
		If myConfigFolder = "" Then ConfigFolder = ""
		On Error Resume Next
		Set TextStream = FSO.GetFile(FSO.BuildPath(CacheFolder, "VSTScanPaths.ini")).OpenAsTextStream(1) : Content = TextStream.ReadAll : TextStream.Close
		If Err.Number <> 0 Then
			On Error Goto 0
			MsgBox "No valid VST Scan Paths specified..." & Chr(13) & "There won't be any VST Plugins created for your Hosts Scan Paths!", , "VST2 Plugin Manager"
		Else
			On Error Goto 0
			For Each Line in Split(Content, vbCrLf)
				AddVSTScanPath(Line)
			Next
		End If
		On Error Resume Next
		FSO.CreateFolder(FSO.BuildPath(CacheFolder, "categories"))
		On Error Goto 0
		Messager.Write "action", "Reading cached VST2 Plugin information..."
		ReadCache = ReadCategories(FSO.BuildPath(CacheFolder, "categories"))
		Messager.Write "action", ""
	End Function
	
'==============================================================================
	Private Function ReadCategories(CategoryFolder)
		ReadCategories = False
		On Error Resume Next
		Dim SubFolder : For Each SubFolder in FSO.GetFolder(CategoryFolder).SubFolders
			ReadCategories(SubFolder.Path)
		Next
		If Err.Number > 0 Then Exit Function
		On Error Goto 0
		Dim VSTScanPath, hostedBy, usageIn, TextStream, Content, Line, CacheInfo, File : For Each File in FSO.GetFolder(CategoryFolder).Files
			If CategoryFiles.Exists(File.Name) Then
				FSO.DeleteFile(File)
			Else
				If LCase(FSO.GetExtensionName(File)) = "ini" Then
					On Error Resume Next
					Set TextStream = File.OpenAsTextStream(1) : Content = TextStream.ReadAll 
					If Err.Number = 0 Then
						On Error Goto 0
						For Each Line in Split(Content, vbCrLf)
							CacheInfo = Split(Line, Chr(06))
							If UBound(CacheInfo) >= 0 Then
								If LCase(CacheInfo(0)) = "hostedby" Then
									hostedBy = FSO.GetBaseName(File.Name) & ".hostedby"
									On Error Resume Next
									CachedInfos.Add hostedBy, CreateObject("Scripting.Dictionary")
									If Err.Number = 0 Then 
										CachedInfos(hostedBy).Add "ID", File.Path
										CachedInfos(hostedBy).Add "Usage", CacheInfo(1)
										If Err.Number <> 0 Then CachedInfos(hostedBy).Add "Usage", "@all"
										CachedInfos(hostedBy).Add "As", CacheInfo(2) 
										If Err.Number <> 0 Then CachedInfos(hostedBy).Add "As", FSO.GetBaseName(File.Name)
									End If
									On Error Goto 0
								ElseIf InStr(LCase(CacheInfo(0)), "usagein:") = 1 Then
									usageIn = FSO.GetBaseName(File.Name) & "." & CacheInfo(0)
									On Error Resume Next
									CachedInfos.Add usageIn, CreateObject("Scripting.Dictionary")
									If Err.Number = 0 Then 
										CachedInfos(usageIn).Add "ID", File.Path
										CachedInfos(usageIn).Add "Usage", CacheInfo(1)
										If Err.Number <> 0 Then CachedInfos(usageIn).Add "Usage", "@defaultUsage"
										CachedInfos(usageIn).Add "As", CacheInfo(2)
										If Err.Number <> 0 Then CachedInfos(usageIn).Add "As", "@defaultName"
									End If
									On Error Goto 0
								Else
									On Error Resume Next
									CachedInfos.Add CacheInfo(0), CreateObject("Scripting.Dictionary")
									If Err.Number = 0 Then
										CachedInfos(CacheInfo(0)).Add "ID", File.Path
										On Error Resume Next
										CachedInfos(CacheInfo(0)).Add "Created", CDbl(CacheInfo(1))
										If Err.Number <> 0 Then CachedInfos(CacheInfo(0)).Add "Created", CDbl(0)
										CachedInfos(CacheInfo(0)).Add "LastModified", CDbl(CacheInfo(2))
										If Err.Number <> 0 Then CachedInfos(CacheInfo(0)).Add "LastModified", CDbl(0)
										CachedInfos(CacheInfo(0)).Add "Type", CacheInfo(3)
										If Err.Number <> 0 Then CachedInfos(CacheInfo(0)).Add "Type", ""
										If FSO.FileExists(CacheInfo(0)) Then
											CachedInfos(CacheInfo(0)).Add "Active", CacheInfo(4)
											If Err.Number <> 0 Then
												CachedInfos(CacheInfo(0)).Add "Active", " "
											End If
										Else
											CachedInfos(CacheInfo(0)).Add "Active", " "
										End If
									End If
									On Error Goto 0
								End If
							End If
						Next
					End If
					CategoryFiles.Add File.Name, ""
				End If
				TextStream.Close
				On Error Goto 0
			End If
		Next
		ReadCategories = True
	End Function

'==============================================================================
	Private Sub Scan(ScanFolder, hard, newDlls)
		' -- dll files einlesen
		On Error Resume Next
		Dim SubFolder : For Each SubFolder in FSO.GetFolder(ScanFolder).SubFolders
			If SubFolder.Path <> AppDir Then
				Scan SubFolder.Path, hard, newDlls
			End If
		Next
		If Err.Number <> 0 Then Exit Sub
		On Error Goto 0
		On Error Resume Next
		Dim PluginType, DateCreated, DateLastModified, File : For Each File in FSO.GetFolder(ScanFolder).Files
			If LCase(FSO.GetExtensionName(File)) = "dll" Then
				Messager.Write "status2", File.Name
				If CachedInfos.Exists(File.Path) Then
					If CachedInfos(File.Path)("Type") = "ax64" Then
						DateCreated = CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name & "64")).DateCreated))
						DateLastModified = CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name & "64")).DateLastModified)) 
					ElseIf CachedInfos(File.Path)("Type") = "ax32" Then
						DateCreated = CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name)).DateCreated))
						DateLastModified = CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name)).DateLastModified))
					Else
						DateCreated = CDbl(DateDiff("s", 0, File.DateCreated))
						DateLastModified = CDbl(DateDiff("s", 0, File.DateLastModified))
					End If
					If CachedInfos(File.Path)("Created") < DateCreated Or CachedInfos(File.Path)("LastModified") < DateLastModified Or hard = True Then
						PluginType = DllType(File)
						If PluginType <> "" Then
							If CachedInfos(File.Path)("ID") = "!NoVSTPluginDLL.ini" Then CachedInfos(File.Path)("ID") = DllID(FSO.GetBaseName(File))
							CachedInfos(File.Path)("Created") = DateCreated
							CachedInfos(File.Path)("LastModified") = DateLastModified
						Else
							CachedInfos(File.Path)("ID") = "!NoVSTPluginDLL.ini"
							CachedInfos(File.Path)("Created") = DateCreated
							CachedInfos(File.Path)("LastModified") = DateLastModified
						End If
						CachedInfos(File.Path).Add "Type", PluginType
						CachedInfos(File.Path)("Active") = "X"
					End If
				Else
					PluginType = DllType(File)
					If PluginType <> "" Then 
						CachedInfos.Add File.Path, CreateObject("Scripting.Dictionary")
						CachedInfos(File.Path).Add "ID", DllID(FSO.GetBaseName(File))
						If PluginType = "ax64" Then
							CachedInfos(File.Path).Add "Created", CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name & "64")).DateCreated))
							CachedInfos(File.Path).Add "LastModified", CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name & "64")).DateLastModified)) 
						ElseIf PluginType = "ax32" Then
							CachedInfos(File.Path).Add "Created", CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name)).DateCreated))
							CachedInfos(File.Path).Add "LastModified", CDbl(DateDiff("s", 0, FSO.GetFile(AutomapClients(File.Name)).DateLastModified))
						Else
							CachedInfos(File.Path).Add "Created", CDbl(DateDiff("s", 0, File.DateCreated))
							CachedInfos(File.Path).Add "LastModified", CDbl(DateDiff("s", 0, File.DateLastModified))
						End If
						CachedInfos(File.Path).Add "Type", PluginType
						CachedInfos(File.Path)("Active") = "X"
						newDlls = True
					Else
						CachedInfos.Add File.Path, CreateObject("Scripting.Dictionary")
						CachedInfos(File.Path).Add "ID", "!NoVSTPluginDLL.ini"
						CachedInfos(File.Path).Add "Created", CDbl(DateDiff("s", 0, File.DateCreated))
						CachedInfos(File.Path).Add "LastModified", CDbl(DateDiff("s", 0, File.DateLastModified))
						CachedInfos(File.Path).Add "Type", PluginType
						CachedInfos(File.Path)("Active") = "X"
					End If
				End If
				Messager.Write "status2", ""
			End If
			Set File = Nothing
		Next
	End Sub	

'==============================================================================
	Private Function DllID(sName)
		sName = LCase(sName)
		Dim i : For i = 1 to Len(sName)
			If InStr("abcdefghijklmnopqrstuvwxyz0123456789", Mid(sName, i, 1)) > 0 Then DllID = DllID & Mid(sName, i, 1)
		Next : i = Empty
		DllId = Replace(DllID, "32", "")
		DllId = Replace(DllID, "64", "")
		DllId = Replace(DllID, "86", "")
		If Right(DllID, 7) = "automap" Then DllID = Left(DllID, Len(DllID) - 7)
		If Right(DllID, 1) = "x" Then DllID = Left(DllID, Len(DllID) - 1)
		DllID = DllID & ".ini"
	End Function

'==============================================================================
	Private Function DllType(oFile)  
		Dim oTS, A1c, AEx()
		Dim iNumc, iNum2c, iEx, iOffset, NumExports, TSOffset, iMagic
		Dim s1c, sB, sMarker
		Dim NumSections, OptHeaderSize, ExpTableOffsetRVA, ExpTableOffsetRaw, ExpTableSize
		Dim FunctionNameOffset, FuncFirstOffset, FuncLastOffset
		Dim NamePointerRVA, NamePointerRaw
		Dim SectionVSize, SectionRVA, SectionRawOffset
		If ScannedFiles.Exists(oFile) Then DllType = ScannedFiles(oFile) : Exit Function
		On Error Resume Next
		Set oTS = oFile.OpenAsTextStream(1)
	        s1c = oTS.Read(2048) '-- Read first 2 KB.
        	oTS.Close
		Set oTS = Nothing    
		If Err.Number <> 0 Then Exit Function
		On Error Goto 0
		A1c = GetArray(Mid(s1c, 61, 2))  	'-- get number value at offset 60 that points to PE signature address.
		iNumc = (GetNumFromBytes(A1c) + 1)  '-- get offset of "PE00"
		sB = GetByteString(s1c, False)  	'-- get a workable string with Chr(0) replaced by "*".       
		sMarker = Mid(sB, iNumc, 4) 
		If (sMarker = "PE**") Then
			'-- Get export table and section table offsets and sizes.
			iNum2c = iNumc + 6 'number of sections.
			A1c = GetArray(Mid(s1c, iNum2c, 2))
			NumSections = GetNumFromBytes(A1c)
			iNum2c = iNumc + 20 ' size of optional header.
			A1c = GetArray(Mid(s1c, iNum2c, 2))
			OptHeaderSize = GetNumFromBytes(A1c)
			iNum2c =  iNumc + 24  '-- point at first 2 bytes of optional table to get 32 or 64 bit.
			A1c = GetArray(Mid(s1c, iNum2c, 2))
			iMagic = GetNumFromBytes(A1c)   
			If iMagic = 523 Then  '--64-bit. 
				iNum2c =  iNumc + 136  '4 + 20 + 112   	'--   PE** (4 bytes) + 20 bytes for COFF header + 112 bytes into optional header to reach Export Table address and size.
			ElseIf iMagic = 267 Then 
				iNum2c =  iNumc + 120  '4 + 20 + 96    	'--   PE** (4 bytes) + 20 bytes for COFF header + 96 bytes into optional header to reach Export Table address and size.
			End If
			If iMagic = 523 Or iMagic = 267 Then
				A1c = GetArray(Mid(s1c, iNum2c, 4))
				ExpTableOffsetRVA = GetNumFromBytes(A1c)  	'-- get RVA offset of export table..
				A1c = GetArray(Mid(s1c, iNum2c + 4, 4))
				ExpTableSize = GetNumFromBytes(A1c)  
				If ExpTableOffsetRVA >= 1 And ExpTableSize >= 1 Then
					iNum2c = iNumc + OptHeaderSize + 24 ' beginning of section table.
					'-- loop through section headers to find section containing export table.
					'-- it will be the section that starts at or before export table offset, and ends after export table start.
					'-- these are all virtual offsets (RVA) but once the section is found, the section's raw offset
					'-- can be obtained. Then the raw export table offset can be obtained by subtracting the export
					'-- section start RVA from the export table RVA, to get the offset of the export table into the section.
					'-- Then add that number to the raw offset to get export table offset on disk.
					For iEx = 0 to NumSections - 1   
						iOffset = iNum2c + (iEx * 40) + 8  'get vsize of section
						A1c = GetArray(Mid(s1c, iOffset, 4))
						SectionVSize = GetNumFromBytes(A1c)
						A1c = GetArray(Mid(s1c, iOffset + 4, 4))  'get VA
						SectionRVA = GetNumFromBytes(A1c)
						If (SectionRVA <= ExpTableOffsetRVA) And ((SectionRVA + SectionVSize)  > ExpTableOffsetRVA) Then 
							A1c = GetArray(Mid(s1c, iOffset + 12, 4))  'get raw offset
							SectionRawOffset = GetNumFromBytes(A1c)  
							Exit For
						End If
					Next  
					'-- export table RVA - section RVA = export table offset into section. Add that to the section raw offset.
					ExpTableOffsetRaw = ( ExpTableOffsetRVA - SectionRVA) +  SectionRawOffset 
					'-- ready to read export table.
				    	On Error Resume Next
					Set oTS = oFile.OpenAsTextStream(1)
					oTS.skip ExpTableOffsetRaw + 24  'number of name pointers.
					s1c = oTS.read(4)
					If Err.Number <> 0 Then Exit Function
					On Error Goto 0
					A1c = GetArray(Mid(s1c, 1, 4))
					NumExports = GetNumFromBytes(A1c) 
					If NumExports < 1 Then 
						oTS.close
						Set oTS = Nothing
					Else
						oTS.skip 4  '--move to 32 offset into export table to get offset of export pointers.
						On Error Resume Next
						s1c = oTS.read(4)
						If Err.Number <> 0 Then Exit Function
						On Error Goto 0
						A1c = GetArray(Mid(s1c, 1, 4))
						NamePointerRVA = GetNumFromBytes(A1c)
						NamePointerRaw = (NamePointerRVA - SectionRVA) + SectionRawOffset  
						ReDim AEx(NumExports - 1)
						TSOffset = ExpTableOffsetRaw + 36
						oTS.skip (NamePointerRaw - TSOffset) 
						TSOffset = TSOffset + (NamePointerRaw - TSOffset) 
						For iEx = 0 to NumExports - 1
							s1c = oTS.Read(4)
							TSOffset = TSOffset + 4
							A1c = GetArray(Mid(s1c, 1, 4))
							FunctionNameOffset = GetNumFromBytes(A1c)
							FunctionNameOffset = (FunctionNameOffset - SectionRVA) + SectionRawOffset  
							AEx(iEx) = FunctionNameOffset
						Next  
						QuickSort AEx, 0, 0  '-- function name offsets are not always listed in order!
						FuncFirstOffset = AEx(0)
						FuncLastOffset = AEx(NumExports - 1)
						On Error Resume Next
						oTS.skip (FuncFirstOffset  - TSOffset)
						s1c = oTS.read((FuncLastOffset - FuncFirstOffset) + 40)
						oTS.close
						Set oTS = Nothing
						If Err.Number <> 0 Then Exit Function
						On Error Goto 0
						s1c = "*" & GetByteString(s1c, False) & "*"
						'-- Filter VSTPluginMain entries
						If (InStr(s1c, "*VSTPluginMain*") > 0 Or InStr(s1c, "*main*") > 0) And InStr(s1c, "*JBridgeBootstrap*") = 0 And InStr(s1c, "*isVST2PluginManagerLoader*") = 0 Then
							If iMagic = 523 Then  '--64-bit. 
								If AutomapClients.Exists(oFile.Name & "64") Then
									On Error Resume Next
										If DllType(FSO.GetFile(AutomapClients(oFile.Name & "64"))) = "x64" Then DllType = "ax64"
									On Error Goto 0
								Else
									DllType = "x64"
								End If
							Else
								If AutomapClients.Exists(oFile.Name) Then
									On Error Resume Next
										If DllType(FSO.GetFile(AutomapClients(oFile.Name))) = "x32" Then DllType = "ax32"
									On Error Goto 0
								Else
									DllType = "x32"
								End If
							End If
						Else
							If InStr(s1c, "*JBridgeBootstrap*") <> 0 Then
								If CheckjBridge = False Then
									CheckjBridge = True
									MsgBox oFile.Path & " is a jBridged Plugin DLL. jBridged automapped or jBridged native Plugin DLLs are not supported. Please automap your native Plugins instead!", , "VST2 Plugin Manager"
								End If
							End If
						End If
					End If
				End If
			End If
		End If
		ScannedFiles.Add oFile, DllType
	End Function

'==============================================================================
	Private Function GetByteString(sStr, SnipUnicode)
		Dim sRet, iLen, iA, iLen2, A2cvi()
		On Error Resume Next
		iLen2 = 0
		If (SnipUnicode = False) Then
			ReDim A2cvi(len(sStr) - 1)
			For iLen = 1 to Len(sStr)
				iA = Asc(Mid(sStr, iLen, 1))
				If iA = 0 Then iA = 42  '-- converts 0-byte to *
				A2cvi(iLen - 1) = Chr(iA)
			Next
		Else     
			ReDim A2cvi((len(sStr) \ 2) - 1)
			For iLen = 1 to Len(sStr) step 2
				iA = Asc(Mid(sStr, iLen, 1))
                If iA = 0 Then iA = 42  '-- converts 0-byte to *
				A2cvi(iLen2) = Chr(iA)
				iLen2 = iLen2 + 1
			Next  
		End If     
		GetByteString = Join(A2cvi, "")
	End Function

'==============================================================================
	Private Function GetArray(sStr)
		Dim iA, Len1, Len2, AStr()
		On Error Resume Next
		Len1 = Len(sStr)
		ReDim AStr(Len1 - 1)
		For iA = 1 to Len1
			AStr(iA - 1) = Asc(Mid(sStr, iA, 1))
		Next      
        GetArray = AStr    
	End Function

'==============================================================================
	Private Function GetNumFromBytes(ABytes)
		Dim Num1
		Err.Clear
        On Error Resume Next
        GetNumFromBytes = -1
		Num1 = ABytes(0) + (ABytes(1) * 256)
		If (UBound(ABytes) = 3) Then
			Num1 = Num1 + (ABytes(2) * 65536) + (ABytes(3) * 16777216)
		End If
		If (Err.number = 0) Then GetNumFromBytes = Num1
	End Function
	
'==============================================================================
	Private Sub QuickSort(AIn, LBeg, LEnd)
		Dim LBeg2, vMid, LEnd2, vSwap
		On Error Resume Next
		If LEnd = 0 Then LEnd = UBound(AIn)
		LBeg2 = LBeg
		LEnd2 = LEnd
		vMid = AIn((LBeg + LEnd) \ 2)
		Do
			Do While AIn(LBeg2) < vMid And LBeg2 < LEnd   
				LBeg2 = LBeg2 + 1
			Loop
			Do While vMid < AIn(LEnd2) And LEnd2 > LBeg   
				LEnd2 = LEnd2 - 1
			Loop
			If LBeg2 <= LEnd2 Then
				vSwap = AIn(LBeg2)
				AIn(LBeg2) = AIn(LEnd2)
				AIn(LEnd2) = vSwap
				LBeg2 = LBeg2 + 1
				LEnd2 = LEnd2 - 1
			End If
		Loop Until LBeg2 > LEnd2
		If LBeg < LEnd2 Then QuickSort AIn, LBeg, LEnd2
		If LBeg2 < LEnd Then QuickSort AIn, LBeg2, LEnd
	End Sub

'==============================================================================
End Class



'******************************************************************************

Class cl_Messager

	Private IE
	Private IEAvailable
	Private IEstarted
	
	Public Sub Class_Initialize
		On Error Resume Next
		Set IE = CreateObject("InternetExplorer.Application")
		If Err.Number = 0 Then
			On Error Goto 0
			IEAvailable = True
			IE.offline = True
			IE.AddressBar = False
			IE.MenuBar = False
			IE.StatusBar = False
			IE.ToolBar = False
			On Error Goto 0
		Else
			On Error Goto 0
			IEAvailable = False
			If MsgBox("Internet Explorer is not available to show to you the progress of the script. You can run the script without this progress information", 1, "VST2 Plugin Manager") = 2 Then WScript.Quit(0)
		End If
	End Sub
	
	Public Sub Class_Terminate
		On Error Resume Next
		IE.Quit
		On Error Goto 0
	End Sub

	Private Sub Start(url, Top, Left, Height, Width)
		IE.Top = Top
		IE.Left = Left
		IE.Height = Height
		IE.Width = Width
		IE.visible = True
		IE.navigate url
		Do While IE.Busy: Loop
	End Sub

	Public Sub Write(field, text)
		If IEAvailable = True Then
			On Error Resume Next
			If IEstarted <> True And text <> "" Then
				IEstarted = True
				Start AppDir & "/data/Messager.html", 300, 400, 186, 640
				If Err.Number <> 0 Then
					CreateObject("WScript.Shell").Run AppDir & "/data/Messager.html"
				Else
					IE.document.getElementByID("action").innerHTML = ""
					IE.document.getElementByID("status1").innerHTML = ""
					IE.document.getElementByID("status2").innerHTML = ""
					If Err.Number <> 0 Then
						IEAvailable = False
					End if
				End If
			End If
			On Error Goto 0
		End If
		If IEAvailable = True Then
			On Error Resume Next
			IE.document.getElementByID(field).innerHTML = text
			If field = "action" Then
				IE.document.getElementByID("status1").innerHTML = ""
				IE.document.getElementByID("status2").innerHTML = ""
			End If
			If field = "status1" Then
				IE.document.getElementByID("status2").innerHTML = ""
			End If
			If Err.Number <> 0 Then
				WScript.Quit(0)
			End If
			On Error Goto 0
		Else
			If field = "action" And text = "finished..." Then
				If MsgBox(text, 1, "VST2 Plugin Manager") = 2 Then WScript.Quit(0)
			End If
		End If
	End Sub
	
End Class